; timer2+CCP3(PWM half bridge P3A(RB5) P3B(RE1)f[eB 20% 15.6kHz 2017/01/04
; keNmW[ PIC18F46K22 }CRLbg Ver2013.12.08p
;   http://akizukidenshi.com/catalog/g/gK-07231/
;   16MHzɌPIC64MHzŋ쓮
; MPLAB X IDE v3.45 Microchip MPASM(v5.70)
; PicKit 3

	#INCLUDE <p18f46k22.inc>
	; U(16MHz) NbN PLLL(*4) vC}NbNL  EHb`hbO^C} dvO݃[h
	CONFIG FOSC = HSHP,PLLCFG=ON,PRICLKEN=ON,WDTEN=OFF,LVP=OFF

bank0	UDATA_ACS   ; ϐ̒` ANZXoN
arg16	RES	2

	CODE
	org	0
	goto	start

start
	BANKSEL	CCPTMRS0
	clrf	CCPTMRS0,BANKED  ;   Timer2\[XƂ
	movlw	0ffh
	movwf	PR2
	movlw	b'10001100'      ;   PWM Half-Bridge
	movwf	CCP3CON,BANKED
	;	movlw	b'00000110'      ;   PS 1:4 Timer2 On 16MHz/16/256/4=3.90625kHz
	;	movlw	b'00000101'      ;   PS 1:4 Timer2 On 16MHz/4/256/4=15.6kHz
	movlw	b'00000100'      ;   PS 1:1 Timer2 On 16MHz/256/4=62.5kHz
	movwf	T2CON

	movlw	b'00000000' ;	fbg^C
	movwf	PWM3CON,BANKED

	movlw	b'00011111'     ;   RB5IO
	movwf	ANSELB,BANKED   ;   bank 0Fh
	movlw	b'00011111'     ;   RB5Out
	movwf	TRISB

	movlw	b'00000101'     ;   RE1IO
	movwf	ANSELE,BANKED   ;   bank 0Fh
	movlw	b'00000101'     ;   RE1Out
	movwf	TRISE
	
CCP3_VALUE  EQU	d'208'
	
	movlw	LOW CCP3_VALUE
	movwf	arg16
	movlw	HIGH CCP3_VALUE
	movwf	arg16+1
	call	SetDCPWM3
	bra	$

;        PWMݒ arg16:pX
SetDCPWM3
	movlw	b'11001111'
	andwf	CCP3CON,BANKED 
	movf	arg16,W
	andlw	b'00000011'
	swapf	WREG
	iorwf	CCP3CON,BANKED 
	bcf	STATUS,C
	rrcf	arg16+1
	rrcf	arg16
	bcf	STATUS,C
	rrcf	arg16+1
	rrcf	arg16
	movf	arg16,W
	movwf	CCPR3L,BANKED 
	return

	END
